diarescript = {};
$(document).ready(function() {
	diarescript.canvas = [];
	diarescript.waitdelay = 1000;
	diarescript.logging = true;
	$('script.function[type="text/diarescript"]').each(function(i,ele) {
		var methodName = $(ele).attr('name');
		var w = $(ele).attr('width');
		var h = $(ele).attr('height');
		if (w && h) {
			var c = $('<canvas id="diarescriptCanvas'+i+'" width="'+w+'" height="'+h+'">Error</canvas>');
			c.appendTo($('div#diarescript'));
			diarescript.canvas.push(c);
		}
		var code = $(ele).html();
		code = code.trim().replace(/\t/g,'').replace(/  /g,' ');
		if (code.toUpperCase() != code) {
			throw "Error";
		}
		var genCode = '';
		var lines = code.split('\n');
		for(var i2=0;i2<lines.length;i2++) {
			var line = lines[i2];
			if (line.indexOf('IGNORE ') > -1) {
				continue;
			}
			var commands = line.split(' ');
			var genLineStart = '\n/*'+line+'*/\ndiarescript.lastResult = ';
			var genLineEnd = ';';
			for(var j=0;j<commands.length;j++) {
				var command = commands[j];
				switch(command.toLowerCase()) {
					case 'say':
						genLineStart += 'alert(';
						genLineEnd = ')' + genLineEnd;
						break;
					case 'be':
						genLineStart += '=';
						break;
					case 'plus':
						genLineStart += '+';
						break;
					case 'and':
						genLineStart += '&&';
						break;
					case 'minus':
						genLineStart += '-';
						break;
					case 'times':
						genLineStart += '*';
						break;
					case 'dividedby':
						genLineStart += '/';
						break;
					case 'display':
						genLineStart += 'alert(';
						genLineEnd = ')' + genLineEnd;
						break;
					case 'that':
						genLineStart += 'diarescript.lastResult';
						break;
					case 'parameter':
						genLineStart += 'parameter';
						break;
					case 'on':
						genLineStart += 'true';
						break;
					case 'off':
						genLineStart += 'false';
						break;
					case 'randbit':
						genLineStart += '(function(seed){ return ((Math.sqrt(Math.random(seed)*Math.random(seed))< 0.5) ? 1 : 0)})(';//Math.Random doesn't generate random enough numbers in a single call
						genLineEnd = ')' + genLineEnd;
						break;
					case 'log':
						genLineStart += '(function(msg){if(diarescript.logging){console.log(msg)}})(';
						genLineEnd = ')' + genLineEnd;
						break;
					case 'draw':
						genLineStart += '(function(imagedata){ if(imagedata){$("#diarescriptCanvas'+i+'").get(0).getContext("2d").putImageData(imagedata, 0, 0);}else{return $("#diarescriptCanvas'+i+'").get(0).getContext("2d").getImageData(0, 0, $("#diarescriptCanvas'+i+'").get(0).width, $("#diarescriptCanvas'+i+'").get(0).height);}})(';
						genLineEnd = ')' + genLineEnd;
						break;
					case 'process':
						genLineStart += '(function(data){if(Object.prototype.toString.call(data).indexOf("Array") > -1) {for(var i=0;i<data.length;i++) {data[i]=arguments.callee(data[i]);}return data;}else{return diarescript.processor(data);}})(';
						genLineEnd = ')' + genLineEnd;
						break;
					case 'result':
						genLineStart = 'return ';
						break;
					case 'range':
						genLineStart += '(function(length){var a=[];for(var i=0;i<length;i++){a.push(i);}return a;})(';
						genLineEnd = ')' + genLineEnd;
						break;
					case 'wait':
						genLineStart += 'setTimeout(';
						genLineEnd = ',diarescript.waitdelay)' + genLineEnd;
						break;
					case 'ifzero':
						genLineStart += '(function(){if(diarescript.lastResult == 0){';
						genLineEnd = '}})()' + genLineEnd;
						break;
					case 'call':
						genLineEnd = '()' + genLineEnd;
						break;
					case 'button':
						genLineStart += "$(document.body).append($('<input type=\"button\" value=\"Click\"/>').click(";
						genLineEnd = "))" + genLineEnd;
						break;
					default:
						if (command.indexOf('THAT.') == 0) {
							genLineStart += command.toLowerCase().replace(/that/,'diarescript.lastResult');
						}else{
							if (isNaN(parseInt(command))) {
								if(command.indexOf('!',command.length-1) >= 0) {//string
									genLineStart += "'" + command.substr(0,command.length-1) + "'";
								}else{ //variable
									genLineStart += 'diarescript.' + command.toLowerCase();
								}
							}else{ //number
								genLineStart += command;
							}
						}
				}
			}
			genCode += genLineStart + genLineEnd;
		}
		genCode = 'diarescript["'+methodName+'"]=function(parameter){'+genCode+'}';
		console.log('/*====GENERATED CODE====*/\n'+genCode);
		eval(genCode);
	});
	diarescript.start();
});